#ifndef Q2_H
#define Q2_H

#include "deque.h"

template <typename T> class Fila {
 public:
  Fila(int capacidade) : q(capacidade) {}
  ~Fila() {}
  void enfileira(const T & arg);
  T desenfileira();
  T & frente() const;
  bool vazia() const;
  bool cheia() const;
  int comprimento();
 private:
  deque<T> q;
};

template <typename T> class Pilha {
 public:
  Pilha(int capacidade) : q(capacidade) {}
  ~Pilha() {}
  void push(const T & arg);
  T pop();
  T & top() const;
  bool vazia() const;
  bool cheia() const;
  int comprimento();
 private:
  deque<T> q;
};

#endif
